function Base.show(io::IO, ::Type{<:PermGroup{I}}) where {I}
    return print(io, PermGroup, "{$I, …}")
end
# function Base.show(io::IO, ::Type{<:Permutation{I, G}}) where {I, G}
#     return print(io, Permutation, "{$I, …}")
# end
function Base.show(io::IO, G::PermGroup)
    print(io, "PermGroup( ")
    join(io, gens(G), ", ")
    return print(io, " )")
end

function Base.show(io::IO, ::MIME"text/plain", G::PermGroup)
    o = isdefined(G, :stabchain) ? " of order $(order(StabilizerChain(G)))" : ""
    ngen = ngens(G)

    println(
        io,
        "Permutation group on ",
        ngen,
        " generator",
        ngen > 1 ? "s" : "",
        o,
        " generated by",
    )
    return Base.print_array(io, gens(G))
end

# Base.show(io::IO, g::Permutation) = show(io, Perm.perm(g))
